%define	name	Glide_V3
%define	version	2.60.16
%define	release	1.1
%define	prefix	/usr

Summary:	Glide runtime for 3Dfx Voodoo Banshee and Voodoo3 boards
Name:		%{name}
Version:	%{version}
Release:	%{release}
Prefix:		%{prefix}
Group:		System/Libraries
Copyright:	3DFX GLIDE Source Code General Public License
URL:		http://www.3dfx.com	
Vendor:		3Dfx Interactive Inc.
Source:		GlideV3.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
ExclusiveArch:	i386 i486 i586 i686 k6 k7

%description 
This package now includes both Glide2x and Glide3x.  Glide is a
lowlevel API for accessing 3dfx Interactive's Voodoo Hardware.  This
version of Glide supports Voodoo Banshee and Voodoo3 based 3D
acclerators.

%package	devel
Summary:	Development libraries for Glide 2.x
Group:		Development/C

%description	devel
This package includes the header files, documentation, and test files
necessary for developing applications that use any of the 3D acceleratos in 
the 3Dfx Interactive Voodoo line.

%prep
%setup -q -c
chmod +x GlideV3/swlibs/include/make/ostype

%build

# A lot of people don't have the compatibility tools/libs installed and
# don't want to build the compat libraries.  However I want to build the
# compat libraries for official 3dfx builds so it gets triggered by
# an env variable.  Resetting to GO and TRUE are used by the Makefile
# to control the buidling of glide2x and not glide3x

if [ "$GLIDE_BUILD_COMPAT" = "TRUE" ]; then
export CC=i386-glibc20-linux-gcc
export GLIDE_BUILD_COMPAT=GO
make -C GlideV3 V3_NODRI

# Save the compat libraries for the install section
mv GlideV3/glide2x/h3/lib/libglide.so.2 \
  GlideV3/glide2x/h3/lib/libglide2x.glibc20
mv GlideV3/swlibs/lib/libtexus.so.1.1 GlideV3/swlibs/lib/libtexus.glibc20

# Clean up the compat build
make -C GlideV3 clean_V3

# Reset this so that other checks pass
export GLIDE_BUILD_COMPAT=TRUE

# Unset CC so it goes back to the default
unset CC
fi

# Now build for native compiler unconditionally
make -C GlideV3 V3_NODRI

%install
[ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

######################################################################
# Create directories
######################################################################

install -d -m 755 $RPM_BUILD_ROOT/usr/lib
install -d -m 755 $RPM_BUILD_ROOT/usr/bin
install -d -m 755 $RPM_BUILD_ROOT/usr/include
install -d -m 755 $RPM_BUILD_ROOT/usr/include/glide
install -d -m 755 $RPM_BUILD_ROOT/usr/include/glide3
install -d -m 755 $RPM_BUILD_ROOT/usr/doc/Glide2
install -d -m 755 $RPM_BUILD_ROOT/usr/doc/Glide3
if [ "$GLIDE_BUILD_COMPAT" = "TRUE" ]; then
install -d -m 755 $RPM_BUILD_ROOT/usr/i386-glibc20-linux/lib
fi

######################################################################
# Install the Glide2x libraries
######################################################################

# Install the native libraries normally
install -m 755 GlideV3/glide2x/h3/lib/libglide.so.2.60 \
  $RPM_BUILD_ROOT/usr/lib/libglide.so.2.60

# Create symlinks
rm -f $RPM_BUILD_ROOT/usr/lib/libglide.so.2
ln -s libglide.so.2.60 $RPM_BUILD_ROOT/usr/lib/libglide.so.2

rm -f $RPM_BUILD_ROOT/usr/lib/libglide.so
ln -s libglide.so.2 $RPM_BUILD_ROOT/usr/lib/libglide.so

# Create a compatibility link for the old name
rm -f $RPM_BUILD_ROOT/usr/lib/libglide2x.so
ln -s libglide.so.2.60 $RPM_BUILD_ROOT/usr/lib/libglide2x.so

rm -f $RPM_BUILD_ROOT/usr/lib/libglide2x.so.2
ln -s libglide2x.so $RPM_BUILD_ROOT/usr/lib/libglide2x.so.2

######################################################################
# Install the Compat Libraries in the compat directory
######################################################################
echo >  compat
if [ "$GLIDE_BUILD_COMPAT" = "TRUE" ]; then
# The compat libs just need the old name, so I don't need to use the new
# naming scheme.
install -m 755 GlideV3/glide2x/h3/lib/libglide2x.glibc20 \
  $RPM_BUILD_ROOT/usr/i386-glibc20-linux/lib/libglide2x_V3.so
rm -f $RPM_BUILD_ROOT/usr/i386-glibc20-linux/lib/libglide2x.so
ln -s libglide2x_V3.so \
  $RPM_BUILD_ROOT/usr/i386-glibc20-linux/lib/libglide2x.so
install -m 755 GlideV3/swlibs/lib/libtexus.glibc20 \
  $RPM_BUILD_ROOT/usr/i386-glibc20-linux/lib/libtexus.so

# This part is a bit of a pain.  The %files section of the spec isn't shell 
# script so I can't make it conditional on $GLIDE_BUILD_COMPAT.  I can 
# include a file, so I write the compat file names to a file.
echo /usr/i386-glibc20-linux/lib/libglide2x_V3.so >  compat
echo /usr/i386-glibc20-linux/lib/libglide2x.so    >> compat
echo /usr/i386-glibc20-linux/lib/libtexus.so      >> compat
fi

######################################################################
# Install the Glide3X libraries
######################################################################
install -m 755 GlideV3/glide3x/h3/lib/libglide3.so.3.10 \
  $RPM_BUILD_ROOT/usr/lib/libglide3.so.3.10
rm -f $RPM_BUILD_ROOT/usr/lib/libglide3x.so

# Create symlinks
rm -f $RPM_BUILD_ROOT/usr/lib/libglide3.so.3
ln -s libglide3.so.3.10 $RPM_BUILD_ROOT/usr/lib/libglide3.so.3

rm -f $RPM_BUILD_ROOT/usr/lib/libglide3.so
ln -s libglide3.so.3 $RPM_BUILD_ROOT/usr/lib/libglide3.so

# Create a compatibility link for the old name
rm -f $RPM_BUILD_ROOT/usr/lib/libglide3x.so
ln -s libglide3.so.3 $RPM_BUILD_ROOT/usr/lib/libglide3x.so

rm -f $RPM_BUILD_ROOT/usr/lib/libglide3x.so.3
ln -s libglide3x.so $RPM_BUILD_ROOT/usr/lib/libglide3x.so.3

######################################################################
# Install Texus
######################################################################
install -m 755 GlideV3/swlibs/lib/libtexus.so.1.1 $RPM_BUILD_ROOT/usr/lib

rm -f $RPM_BUILD_ROOT/usr/lib/libtexus.so.1
ln -s libtexus.so.1.1 $RPM_BUILD_ROOT/usr/lib/libtexus.so.1

rm -f $RPM_BUILD_ROOT/usr/lib/libtexus.so
ln -s libtexus.so.1 $RPM_BUILD_ROOT/usr/lib/libtexus.so

install -m 755 GlideV3/swlibs/bin/texus $RPM_BUILD_ROOT/usr/bin


######################################################################
# Install the Glide2x SDK material
######################################################################

# Install the headers
install -m 644 GlideV3/swlibs/include/3dfx.h $RPM_BUILD_ROOT/usr/include/glide
install -m 644 GlideV3/glide2x/h3/include/glide.h \
  $RPM_BUILD_ROOT/usr/include/glide
install -m 644 GlideV3/glide2x/h3/include/glidesys.h \
  $RPM_BUILD_ROOT/usr/include/glide
install -m 644 GlideV3/glide2x/h3/include/glideutl.h \
  $RPM_BUILD_ROOT/usr/include/glide
install -m 644 GlideV3/glide2x/h3/include/sst1vid.h \
  $RPM_BUILD_ROOT/usr/include/glide
install -m 644 GlideV3/glide2x/h3/include/gump.h \
  $RPM_BUILD_ROOT/usr/include/glide
install -m 644 GlideV3/swlibs/include/linutil.h \
  $RPM_BUILD_ROOT/usr/include/glide
install -m 644 GlideV3/swlibs/include/texus.h \
  $RPM_BUILD_ROOT/usr/include/glide

# Install the documentation
install -m 644 GlideV3/glide_license.txt $RPM_BUILD_ROOT/usr/doc/Glide2
install -m 644 GlideV3/docs2x/*.pdf $RPM_BUILD_ROOT/usr/doc/Glide2


######################################################################
# Install the Glide3x SDK material
######################################################################
# Install the headers
install -m 644 GlideV3/swlibs/include/3dfx.h \
  $RPM_BUILD_ROOT/usr/include/glide3
install -m 644 GlideV3/glide3x/h3/include/glide.h \
  $RPM_BUILD_ROOT/usr/include/glide3
install -m 644 GlideV3/glide3x/h3/include/glidesys.h \
  $RPM_BUILD_ROOT/usr/include/glide3
install -m 644 GlideV3/glide3x/h3/include/glideutl.h \
  $RPM_BUILD_ROOT/usr/include/glide3
install -m 644 GlideV3/glide3x/h3/include/sst1vid.h \
  $RPM_BUILD_ROOT/usr/include/glide3
install -m 644 GlideV3/swlibs/include/linutil.h \
  $RPM_BUILD_ROOT/usr/include/glide3
install -m 644 GlideV3/swlibs/include/texus.h \
  $RPM_BUILD_ROOT/usr/include/glide3


# Install the examples and their source
# Make two copies so that the old test3Dfx is still there and
# we now have a consisten testGlide2x, testGlide3x

install -m 755 GlideV3/glide2x/h3/glide/tests/test00 \
$RPM_BUILD_ROOT/usr/bin/test3Dfx

install -m 755 GlideV3/glide2x/h3/glide/tests/test00 \
$RPM_BUILD_ROOT/usr/bin/testGlide2x

install -m 755 GlideV3/glide3x/h3/glide3/tests/test00 \
$RPM_BUILD_ROOT/usr/bin/testGlide3x


# Install the documentation
install -m 644 GlideV3/glide_license.txt $RPM_BUILD_ROOT/usr/doc/Glide3
install -m 644 GlideV3/docs3x/*.pdf $RPM_BUILD_ROOT/usr/doc/Glide3

%clean
[ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;


# This will remove the very old Glide SDK that installed things in 
%post
/sbin/ldconfig

%post devel
/sbin/ldconfig

%postun
/sbin/ldconfig

%files -f compat
%defattr(-,root,root)
%docdir /usr/doc/Glide2
%docdir /usr/doc/Glide3
/usr/doc/Glide2/glide_license.txt
/usr/doc/Glide3/glide_license.txt
/usr/lib/libglide.so.*
/usr/lib/libglide2x.so.*
/usr/lib/libglide3.so.*
/usr/lib/libglide3x.so.*
/usr/lib/libtexus.so.1.1
/usr/lib/libtexus.so.1
/usr/bin/texus
/usr/bin/test3Dfx
/usr/bin/testGlide3x
/usr/bin/testGlide2x

%files devel
%defattr(-,root,root)
/usr/lib/libglide.so
/usr/lib/libglide2x.so
/usr/lib/libglide3x.so
/usr/lib/libglide3.so
/usr/lib/libtexus.so
%docdir /usr/doc/Glide2
%docdir /usr/doc/Glide3
/usr/doc/Glide2/glidepgm.pdf
/usr/doc/Glide2/glideref.pdf
/usr/doc/Glide3/glide3pgm.pdf
/usr/doc/Glide3/glide3ref.pdf
/usr/doc/Glide3/glide3relno.pdf
%dir /usr/include/glide
/usr/include/glide/*
%dir /usr/include/glide3
/usr/include/glide3/*

%changelog
* Thu Jul 13 2000 Ryan Weaver <ryanw@infohwy.com>
  [Glide_V3-2.60.16-1.1]
- Updated to release 16.
- Rebuilt for RedHat 6.1.
- Changed some minor spec formatting issues. (My personal preferences)

* Mon May 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.60.15-4mdk
- ExclusiveArch: i386 i486 i586 i686 k6 k7

* Tue Apr 18 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 2.60.15-3mdk
- Cleaned up the spec file.
- Stuff are installed in a cleaner way.

* Thu Apr 13 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 2.60.15-2mdk
- fix group
- correct file in devel package.
- fix attr

* Wed Mar 23 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 2.60.15-1mdk
- Mandrake package.
- Fix group.

* Wed Feb 23 2000 Joseph Kain <joseph@3dfx.com>
- Revision 15
- Fix to minihwc to stop crashing on reinitialization

* Tue Feb 15 2000 Joseph Kain <joseph@3dfx.com>
- Revision 14
- Fix to the pci library that unmaps boards correctly on shutdown
- Source now supports FreeBSD

* Fri Feb 04 2000 Joseph Kain <joseph@3dfx.com>
- Fixed typo that messed up compatbility symlinks for glide3
- Added libglide3x.so.3 and libglide2x.so.2 that were missing from %files

* Mon Jan 31 2000 Joseph Kain <joseph@3dfx.com>
- Finished making compat build completely optional

* Wed Jan 19 2000 Joseph Kain <joseph@3dfx.com>
- Merged Glide2x and Glide3x kits into a single package.

* Thu Jan 13 2000 Joseph Kain <joseph@3dfx.com>
- Made building compat libraries (for glibc2.0) optional

* Tue Nov 30 1999 Joseph Kain <joseph@3dfx.com>
- Built against initial source release
